// 初始化
$(function() {
	$(window.document).zinit();
});

(function($) {

	// 修改全局设置
	// states:[1,2], 修改前: states[]=1&states[]=2, 修改后: states=1&states=2
	$.ajaxSettings.traditional = true;
	$.ajaxSettings.dataType = "json";

	$.fn.zinit.plugins.add(function() {
		if (window.baidu && baidu.template) {
			// 设置左分隔符为 <#
			baidu.template.LEFT_DELIMITER='<#';
			// 设置右分隔符为 #>
			baidu.template.RIGHT_DELIMITER='#>';
			// 默认不转义, 如果需要转义, 调用Utils.encodeHtml()处理
			baidu.template.ESCAPE = false;
			return true;
		}
	});

	// 只有#号的链接, 不改变location.hash
	$.fn.zinit.nodes.add("a[href='#']", function() {
		$(this).click(function(e) { e.preventDefault(); });
	});
	// 不可编辑的输入框初始化
	$.fn.zinit.nodes.add("input.uneditable, textarea.uneditable", function() {
		$(this).uneditable(true);
	});

	// Utils.succTips / Utils.warnTips
	$.fn.zinit.plugins.add(function() {
		if (Utils) { // mui
			Utils.warnTips = function(msg) {
				Utils.toast(msg);
			};
			Utils.succTips = function(msg) {
				Utils.toast(msg);
			};
			return true;
		}
	});

	$.fn.zinit.plugins.add("zupload", function() {
		var o = this.defaults;
		o.url = Utils.getBaseUrl("actions/file/upload.json"); // 上传文件的URL
		o.error = function(e) {
			Utils.warnTips(e.message);
		};
	});

	/** 表单提交插件 **/
	$.fn.zinit.plugins.add(function() {
		if (!$.zajax) { return; }
		var o = $.zajax.defaults;
		o.options.failTipsOnButton = false; // 失败消息是否显示到按钮上
		o.fn.check = Utils.succ;
		o.fn.loading = { show: Utils.showLoading, stop: Utils.stopLoading };
		o.fn.succTips = function(e, json) {
			var e = this;
			if (e.button) {
				Utils.succTips((e.message || e.button.zoptions().message || e.button.text()) + "成功！");
			} else {
				// 不是点按钮导致的提交,不显示成功消息
			}
		};
		o.fn.failTips = function(json) {
			var e = this;
			if (e.button) {
				// 失败消息, 先取服务器返回的, 再取options.message, 再取按钮data-options配置的message, 再取按钮的文字
				var msg = json && json.message || ((e.message || e.button.zoptions().message || e.button.text()) + "失败！");
				if (e.failTipsOnButton) { // 失败消息是否显示到按钮上
					if ($.fn.warnning) { e.button.warnning(msg); }
					else if ($.fn.msger) { e.button.msger(msg); }
					else { Utils.toast(msg); }
				} else {
					Utils.toast(msg);
				}
			} else {
				// 显示失败消息
				Utils.toast(json && json.message || (e.message ? e.message + "失败！" : "网络异常，请稍后重试！"));
			}
		};
		o.fn.validate = function(doSubmit) {
			if ($.fn.zhhvalidate) {
				this.form.zhhvalidate(function(e) {
					if (e.passed) {
						doSubmit();
					}
				});
			} else {
				doSubmit();
			}
		};
		o.fn.upload = function(callback) {
			if (!this.form) { callback(); return; }
			var button = this.button;

			this.form.find("input.filebox-f[data-zupload]").each(function() {
				var me = $(this);
				var attr = me.attr("data-zupload");
				me.removeAttr("data-zupload");
				me.xcall("textbox").siblings("input[type=file]").attr("data-zupload", attr);
			});
			
			$.zloading("正在上传第1个文件");
			this.form.zupload({
				find : function(o, key) {
					return $(this).find("input[type=file],img").filter(function() {
						var me = $(this);
						var input = me.attr(key);
						var matches = input != undefined && input != "false";
						if (matches) {
							if (me.is("img")) {
							} else { // file
								matches = this.files && this.files.length > 0;
								if (matches) {
									matches = me.val() != me.attr("last-upload");
								}
							}
						}
						return matches;
					});
				},
				process: function(e) {
					//console.log("--> " + "正在上传第"+(e.index+1)+"个文件("+e.percent+"%)");
					$.zloading("正在上传第"+(e.index+1)+"个文件("+e.percent+"%)");
				},
				step: function(e) {
					$.log.debug(e.url);
					var $file = $(e.element);
					if ($file.is("img")) { // img
						// $file.attr("src", e.url); // 会导致立即下载刚上传的图片
						$file.removeAttr(e.key); // 防止重复上传
						if ($file.attr("data-preview-src") != undefined) {
							$file.attr("data-preview-src", e.url); // 处理MUI图片预览
						}
					} else { // file
						$file.attr("last-upload", $file.val()); // 防止重复上传
					}
				},
				done: function(e) {
					callback.call(this, e);
					Utils.stopLoading();
				},
				error:function(e) {
					if (button) {
						button.warnning(e.message);
					} else {
						Utils.warnTips(e.message);
					}
				}
			});
		};
		$.extend(o.options, {
			loading: false,
			crossDomain:true,
			dataType: "json",
			xhrFields: { withCredentials: true }
		});
		return true;
	});

	/** 星级评价插件通用配置及自动初始化<div class="star-rating" data-options="half:true,number:3"></div> **/
	$.fn.zinit.nodes.add(".star-rating, .do-raty", "raty");
	$.fn.zinit.plugins.add("raty", function() {
		this.defaults.path = Utils.getBaseUrl("assets/libs/jquery-raty/star/");
		this.defaults.hints = [];
		this.defaults.targetType = "score";
		this.defaults.size = 24;
	});
	
	/** Camera插件 **/
	$.fn.zinit.nodes.add(".do-camera", function() {
		var me = $(this);
		if ($.fn.zcamera) {
			me.zcamera(me.zoptions());
		}
	});

	/** iCheck插件 **/
	$.fn.zinit.nodes.add(".do-icheck", function() {
		var me = $(this);
		if ($.fn.iCheck) {
			me.iCheck($.extend({}, $.fn.iCheck.zdefaults, me.zoptions()));
		}
	});
	$.fn.zinit.plugins.add("iCheck", function() {
		this.zdefaults = { 
			checkboxClass: 'icheckbox_minimal-blue',
			radioClass: 'iradio_minimal-blue'
		};
	});

	/** 日期选择插件 **/
	$.fn.zinit.nodes.add(".do-datepicker", "datepicker");
	$.fn.zinit.plugins.add("datepicker", function() {
		this.defaults.todayHighlight = true;
		this.defaults.format = "yyyy-mm-dd";
		this.defaults.language = "zh-CN";
		if (this.dates['zh-CN']) {
			this.dates['zh-CN'].format = "yyyy-mm-dd";
			this.dates['zh-CN'].today = "今天";
		}
	});
	
	
	/** select2插件 **/
	$.fn.zinit.plugins.add("select2", function() {
		this.defaults.set("theme", "bootstrap");
		this.defaults.set("language", "zh-CN");
	});
	$.fn.zinit.nodes.add(".do-select2", function() {
		if ($.fn.select2) {
	    	var me = $(this);
	    	me.select2(me.zoptions());
	    	// form.clearForm事件
	    	me.on("clear", function() {
	    		me.val("").trigger("change");
	    	});
		}
	});

	/** 表单验证插件 **/
	$.fn.zinit.nodes.add("form", function() {
		var me = $(this);
		if ($.fn.zhhvalidate) {
			me.zhhvalidate("init");
		}
	});
	$.fn.zinit.plugins.add("zhhvalidate", function() {
		var zv = this.defaults;
		// 自定义AJAX解析函数
		var parse = zv.ajax.parse;
		zv.ajax.parse = function(e, json) {
			if ($.isPlainObject(json)) {
				return { passed:Utils.succ(json), text:json.message };
			} else { // 调用原解析函数
				return parse.call(this, e, json);
			}
		};
		zv.classes["line-error"] = "has-error";
		zv.bind.push({on:"focus", selector:"input, textarea, select", fn:function() {
			$(this).closest(zv.selectors.line.join(",")).addClass("vld-typing");
		}});
		zv.bind.push({on:"blur", selector:"input, textarea, select", fn:function() {
			$(this).closest(zv.selectors.line.join(",")).removeClass("vld-typing");
		}});
		zv.selectors.line.push(".mui-input-row");
		zv.selectors.label.push("label");
	});

	// DataTable
	$.fn.zinit.nodes.add("table[data-table]", function() {
		var me = $(this);
		if ($.fn.dataTable && $.fn.xtable) {
			me.xtable();
		}
	});
	$.fn.zinit.plugins.add(function() {
		if ($.fn.dataTable && $.fn.xtable) {
			$.fn.xtable.power({
				xtable: {
					totalField: "extra.total",
					listField: "body"
				},
				language: {
					infoFiltered: "(从 _MAX_ 条数据中检索)",
					lengthMenu: "每页显示  _MENU_ 条记录",
					info: "共 _TOTAL_ 条 / 显示第_START_到_END_条",
					emptyTable: "&nbsp;",　// No data available in table
					zeroRecords: "抱歉， 没有找到数据",
					infoEmpty: "抱歉， 暂无数据",
					paginate: { first: "首页", previous: "上页", next: "下页", last: "末页" }
				}
			});
			return true;
		}
	});

})(jQuery);
