var ws = null,
	wsOffcanvas = null; //侧滑webview
var wsSearch; //搜索webview
var em = null,
	map = null;
var qidianMarker; //起点标识
var qidianCity; //起点城市
var zhongdianMarker; //终点标识
var zhongdianCity; //终点城市
var isQidian = true; //true未设置起点，false为设置终点
var lastLocation; //最后一次成功的定位信息
// H5 plus事件处理
function plusReady() {
	if(!em || ws) {
		return
	};
	// 获取窗口对象
	ws = plus.webview.currentWebview();
	var wo = ws.opener();
	//高德地图坐标为(116.3974357341,39.9085574220), 百度地图坐标为(116.3975,39.9074)
	var pcenter = new plus.maps.Point(116.3975, 39.9074);
	setTimeout(function() {
		map = new plus.maps.Map("map");
		map.centerAndZoom(pcenter, 16);
		userLocation();
		// 创建子窗口
		createSubview();
	}, 300);
	// 显示页面并关闭等待框
	ws.show("pop-in");
}
if(window.plus) {
	plusReady();
} else {
	document.addEventListener("plusready", plusReady, false);
}
// DOMContentloaded事件处理
document.addEventListener("DOMContentLoaded", function() {
	em = document.getElementById("map");
	window.plus && plusReady();
}, false);

function userLocation() {
	map.showUserLocation(true);

	//百度定位当前位置
	//	getPosBaidu(function(){
	//	}, true);

	//地图定位当前位置
	getPosBaidu(function() {
		map.getUserLocation(function(state, pos) {
			if(0 == state) {
				plus.maps.Map.reverseGeocode(pos, {}, function(event) {
					var address = event.address; // 转换后的地理位置
					setQidianMarker(pos, address);
				}, function(e) {
					Utils.toast("获取定位信息失败");
				});
			}
		});
	});
}

//设置起点
function setQidianMarker(point, label, address) {
	point = new plus.maps.Point(point.longitude, point.latitude);
	map.setCenter(point);
	if(qidianMarker) {
		map.removeOverlay(qidianMarker);
	}
	qidianMarker = new plus.maps.Marker(point);
	if(mui.os.android) {
		qidianMarker.setIcon("/assets/img/home/qidian-big.png");
	} else {
		qidianMarker.setIcon("/assets/img/home/qidian.png");
	}
	qidianMarker.setLabel(label);
	var bubble = new plus.maps.Bubble(address);
	qidianMarker.setBubble(bubble);
	map.addOverlay(qidianMarker);
	plus.webview.getWebviewById("home/maps_sub").evalJS('changeQidian("' + label + '")');
}

//设置终点
function setZhongdianMarker(point, label, address) {
	point = new plus.maps.Point(point.longitude, point.latitude);
	map.setCenter(point);
	if(zhongdianMarker) {
		map.removeOverlay(zhongdianMarker);
	}
	zhongdianMarker = new plus.maps.Marker(point);
	if(mui.os.android) {
		zhongdianMarker.setIcon("/assets/img/home/zhongdian-big.png");
	} else {
		zhongdianMarker.setIcon("/assets/img/home/zhongdian.png");
	}
	zhongdianMarker.setLabel(label);
	var bubble = new plus.maps.Bubble(address);
	zhongdianMarker.setBubble(bubble);
	map.addOverlay(zhongdianMarker);
	plus.webview.getWebviewById("home/maps_sub").evalJS('changeZhongdian("' + label + '")');
	Utils.nav.next("/views/personal/trip-information.html", {}, {
		city: qidianCity,
		zhongdianCity: zhongdianCity,
		origin: qidianMarker.getLabel(),
		originCode: qidianMarker.getPoint(),
		terminal: zhongdianMarker.getLabel(),
		terminalCode: zhongdianMarker.getPoint()
	})
}

//搜索页设置起点终点
function setQZdian(json) {
	json = JSON.parse(json);
	if(isQidian) {
		qidianCity = json.city;
		setQidianMarker(json.point, json.name, json.address);
	} else {
		zhongdianCity = json.city;
		setZhongdianMarker(json.point, json.name, json.address);
	}
}

function createSubview() {
	// 加载起点终点
	var wsub = plus.webview.create('/views/home/maps_sub.html', 'home/maps_sub', {
		left: '5%',
		bottom: '20px',
		width: '90%',
		height: '81px',
		position: 'absolute',
		scrollIndicator: 'none',
		background: 'transparent'
	});
	ws.append(wsub);

	//加载定位按钮
	var wslocation = plus.webview.create('/views/home/maps_location.html', 'home/maps_location', {
		left: '5%',
		bottom: '110px',
		width: '30px',
		height: '30px',
		position: 'absolute',
		scrollIndicator: 'none',
		background: 'transparent'
	});
	ws.append(wslocation);

	//加载侧滑菜单
	wsOffcanvas = plus.webview.create('/views/home/offcanvas.html', 'home/offcanvas', {
		width: "100%",
		left: "-100%",
		zindex: 9999,
		position: 'absolute',
		scrollIndicator: 'none',
		background: 'transparent'
	});
	ws.append(wsOffcanvas);

	// 加载搜索webview
	wsSearch = plus.webview.create('/views/home/maps_search.html', 'home/maps_search', {
		left: '0',
		top: '100%',
		width: '100%',
		height: '100%',
		position: 'absolute',
		scrollIndicator: 'none',
		background: 'transparent'
	});
	ws.append(wsSearch);
}

//设置搜索页选择的城市
var setNowCity = function(name) {
	if(name) {
		Utils.nav.invoke(wsSearch, "setNowCity", name);
	}
}

//百度定位获取城市信息
function getPosBaidu(callback, isSetAddress) {
	plus.geolocation.getCurrentPosition(function getinfo(position) {

		if(position) {
			if(position.address || lastLocation) {
				if(position.address.city) {
					lastLocation = position;
				} else {
					position = lastLocation;
				}
				var city = position.address.city; //获取城市信息
				if(city) {
					qidianCity = city;
					if(isSetAddress) {
						var coords = position.coords; //坐标信息
						var addresses = position.addresses; //地址信息
						if(coords && addresses) {
							setQidianMarker(new plus.maps.Point(coords.longitude, coords.latitude), addresses);
						} else {
							Utils.toast("获取定位信息失败");
							return;
						}
					}
					callback && callback();
					return;
				}
			}
		}
		Utils.toast("获取定位信息失败");
	}, function(e) {
		Utils.toast("获取定位信息失败");
	}, {
		coordsType: "bd09ll",
		provider: 'baidu',
		geocode: true
	});
}

//搜索名称
var searchObj;

function search(json) {
	json = JSON.parse(json);
	if(!searchObj) {
		searchObj = new plus.maps.Search(map);
	}
	searchObj.onPoiSearchComplete = function(state, result) {
		if(state == 0) {
			Utils.nav.invoke(wsSearch, "showList", result.poiList);
		} else {
			Utils.nav.invoke(wsSearch, "showList");
		}
	}
	if(!searchObj.poiSearchInCity(json.city, json.content)) {
		Utils.nav.invoke(wsSearch, "showList");
	}
}

//搜索附近，必须要输出关键词有点坑
function searchNearBy(marker) {
	if(!marker) {
		Utils.nav.invoke(wsSearch, "showList");
		return;
	}
	if(!searchObj) {
		searchObj = new plus.maps.Search(map);
	}
	searchObj.onPoiSearchComplete = function(state, result) {
		if(state == 0) {
			Utils.nav.invoke(wsSearch, "showList", result.poiList);
		} else {
			Utils.nav.invoke(wsSearch, "showList");
		}
	}
	if(!searchObj.poiSearchNearBy("小区", marker.getPoint(), 1000, 0)) {
		Utils.nav.invoke(wsSearch, "showList");
	}
}

//选择起点弹窗搜索
function qidianSearch() {
	isQidian = true;
	wsSearch.setStyle({
		top: '0'
	});
	Utils.nav.invoke(wsSearch, "showMenu");
	searchNearBy(qidianMarker);
	setNowCity(qidianCity);
}

//选择终点弹窗搜索
function zhongdianSearch() {
	isQidian = false;
	if(qidianMarker) {
		wsSearch.setStyle({
			top: '0'
		});
		Utils.nav.invoke(wsSearch, "showMenu");
		searchNearBy(zhongdianMarker);
		setNowCity(zhongdianCity || qidianCity);
	} else {
		Utils.toast("请先设置起点！");
	}
}

+
function($) {

	mui.plusReady(function() {
		//自动登录
		loginUtils.autoLogin();

		//侧滑
		$(".do-offcanvas").on('tap', function() {
			if(loginUtils.checkLoginState()) {
				wsOffcanvas.setStyle({
					left: '0'
				});
				Utils.nav.invoke(wsOffcanvas, "showMenu");
			} else {
				Utils.nav.next("/views/home/login.html");
			}
		});

		// 点击 消息icon
		$(".icon-message").on('tap', function() {
			if(loginUtils.checkLoginState()) {
				Utils.nav.next("/views/personal/message-list.html");
			} else {
				Utils.nav.next("/views/home/login.html");
			}
		});

		plus.runtime.setBadgeNumber(0);
		// 监听点击消息事件
		plus.push.addEventListener("click", function(msg) {
			var pushId = msg.payload;
			var title = "";

			if(msg.aps) { //是否是IOS aps发送消息
				title = msg.aps.alert.title;
				pushId = msg.payload.pushId;
			} else if(mui.os.ios) { //IOS消息与android消息不一致，返回的是content
				if(pushId && pushId.indexOf('default') >= 0) {
					pushId = pushId.substring(7, pushId.length);
				}
				title = msg.content;
			} else if(mui.os.android) { //android返回消息为title
				if(pushId && pushId.indexOf('default') >= 0) {
					pushId = pushId.substring(7, pushId.length);
				}
				title = msg.title;
			}
			//跳转推送通知详情页面
			Utils.nav.next("/views/personal/message-list.html", {
				id: pushId
			});
		}, false);

		plus.push.setAutoNotification(true); //是否显示多条
		plus.push.addEventListener("receive", function(msg) {
			if(mui.os.ios || msg.payload.indexOf('default') >= 0) {
				//类型default为后台服务器发送的payload
				//区分android和IOS，主要是这两种弹出消息展示字段不一样。
				var content = JSON.parse(msg.content);
				if(mui.os.android) {
					var pushId = msg.payload.substring(7, msg.payload.length);
					//接收到创建本地消息
					var options = {
						cover: false,
						title: content.title
					};
					plus.push.createMessage('', pushId, options);
				} else if(mui.os.ios) {
					var pushId = content.payload.substring(7, content.payload.length);
					//接收到创建本地消息
					var options = {
						cover: false,
						title: content.title
					};
					plus.push.createMessage(content.title, pushId, options);
				}
			}
		}, false);

		//更新clientId
		var url = Utils.getBaseUrl('userThird/create.json');
		var param = {
			thirdType: "PUSH",
			thirdCode: plus.push.getClientInfo().clientid
		};
		$.zajax(url, param, true, {
			succ: function(json) {},
			fail: function(json) {}
		});

	});

}(jQuery);