+ function($) {

	mui.plusReady(function() {

		// 点击"登录"
		var $form = $("form[name=login]");
		$(".do-submit").on('tap', function() {
			$form.zhhvalidate({
				tips: false,
				failFast: true
			}, function(e) {
				if(e.passed) {
					var serializeJson = $form.serializeJson();
					loginUtils.autoLogin({
						ajaxParam: serializeJson, //如果不设置则从缓存取
						loading: true, //是否有加载动画，如果不设置则没有
						succ: function() {
							Utils.toast("登录成功！");
							Utils.nav.back();
						}, //成功以后执行的代码
						fail: function(json) {
							
						} //失败以后执行的代码
					});
				} else {
					Utils.toast(e.text);
				}
			});

		});

		// 点击"注册账号"
		$(".register").on('tap', function() {
			Utils.nav.next("/views/home/register.html");
		});

		// 点击"忘记密码"
		$(".forgotPassword").on('tap', function() {
			Utils.nav.next("/views/home/forget-password.html");
		});
		
		//根据openid查询是否帐号存在，如果存在自动登录，如果不存在注册
		var findByOpenid = function(openid, thirdType){
			thirdType = thirdType.toLocaleUpperCase();
			var url = Utils.getBaseUrl("userThird/findUserinfo.json");
			$.zajax(url, {thirdCode:openid, thirdType:thirdType}, true, {
				succ: function(json) {
					var body = json.body;
					if(body){
						loginUtils.autoLogin({
							ajaxParam: {
								account:body.phone,
								password:openid,
								openid:openid,
								thirdType:thirdType
							}, //如果不设置则从缓存取
							loading: true, //是否有加载动画，如果不设置则没有
							succ: function() {
								Utils.toast("登录成功！");
								Utils.nav.back();
							}, //成功以后执行的代码
							fail: function(json) {
								
							} //失败以后执行的代码
						});
					}else{
						//没有此用户去注册
						Utils.nav.next("/views/home/register.html", {}, {thirdCode:openid,	thirdType:thirdType});
					}
				},
				fail: function(json) {
				}
			});
		}

		//第三方登录
		var authWeixin;
		var authQQ;
		plus.oauth.getServices(function(auths) {
			for(var i = 0; i < auths.length; i++) {
				var authThis = auths[i];
				var id = authThis.id;
				if(id == 'weixin') {
					authWeixin = authThis;
					continue;
				} else if(id == 'qq') {
					authQQ = authThis;
					continue;
				}
			}
		}, function(e) {
			
		});
		var authThirdLogin = function(authThird){
			authThird.login(function(e) {
				// 获取登录操作结果
				authThird.getUserInfo(function(e) {
					var openid = authThird.userInfo.openid || authThird.authResult.openid;
					findByOpenid(openid, authThird.id);
					authThird.logout(function(e) {
					}, function(e) {
					});
				}, function(e) {
					Utils.toast('获取用户信息失败');
				});
			}, function(e) {
				Utils.toast('第三方登录失败！');
			});
		}
		var thirdLogin = function(authThird){
			authThirdLogin(authThird);
		}
		$(".do-third-weixin").on('tap', function() {
			thirdLogin(authWeixin);
		});
		$(".do-third-qq").on('tap', function() {
			thirdLogin(authQQ);
		});
	})

}(jQuery);