+ function($) {

	var rows = 10; // 每页 条数

	// 去掉消息未读图标
	window.read = function(id) {
		$("[data-id=" + id + "]").find(".red-dot").remove();
	}

	var getList = function() {
		var url = Utils.getBaseUrl("pushLog/list.json");
		var param = {
			page: page,
			rows: rows
		};
		$.zajax(url, param, true, {
			succ: function(json) {
				var html = Utils.baidu.template("list", json.body);
				var length = json.body.length;
				if(length < rows) {
					mui('#pullrefresh').pullRefresh().endPullupToRefresh(true);
				} else {
					mui('#pullrefresh').pullRefresh().endPullupToRefresh(false);
				}
				$(".list").append(html);

				if(json.extra.total == 0) {
					var html = Utils.baidu.template("list-empty");
					$(".list").html(html);
					$(".list").css("background-color", "#F6F7FB");
					$(".mui-pull-bottom-pocket").addClass("hide");
				} else {
					$(".list").css("background-color", "white");
					$(".mui-pull-bottom-pocket").removeClass("hide");
				}
			},
			fail: function(json) {

			}
		});
	}

	var pulldownRefresh = function() {
		$(".list").empty();
		page = 1;
		getList();

		mui('#pullrefresh').pullRefresh().endPulldownToRefresh(); //refresh completed
		mui('#pullrefresh').pullRefresh().refresh(true);
	}

	var pullupRefresh = function() {
		getList(++page);
	}

	mui.ready(function() {

		mui.init({
			pullRefresh: {
				container: "#pullrefresh", //下拉刷新容器标识，querySelector能定位的css选择器均可，比如：id、.class等
				down: {
					style: 'circle', //必选，下拉刷新样式，目前支持原生5+ ‘circle’ 样式
					color: '#2BD009', //可选，默认“#2BD009” 下拉刷新控件颜色
					height: '50px', //可选,默认50px.下拉刷新控件的高度,
					range: '100px', //可选 默认100px,控件可下拉拖拽的范围
					offset: '44px', //可选 默认0px,下拉刷新控件的起始位置
					auto: true, //可选,默认false.首次加载自动上拉刷新一次
					callback: pulldownRefresh //必选，刷新函数，根据具体业务来编写，比如通过ajax从服务器获取新数据；
				},
				up: {
					height: 100, //可选.默认50.触发上拉加载拖动距离
					auto: false, //可选,默认false.自动上拉加载一次
					contentrefresh: "正在加载...", //可选，正在加载状态时，上拉加载控件上显示的标题内容
					contentnomore: '没有更多数据了', //可选，请求完毕若没有更多数据时显示的提醒内容；
					callback: pullupRefresh //必选，刷新函数，根据具体业务来编写，比如通过ajax从服务器获取新数据；
				}
			}
		});

		// 点击 消息列表box
		$(".list").on('tap', ".box", function() {
			var detailInfo = $(this).data("value");
			if($(this).find(".red-dot")) { // 未读 才传id
				var id = $(this).data("id");

				Utils.nav.next("/views/personal/message-detail.html", {
					id: id
				}, {
					detailInfo: detailInfo
				});
			} else {
				Utils.nav.next("/views/personal/message-detail.html", {}, {
					detailInfo: detailInfo
				});
			}
		});

	})

}(jQuery);