+ function($) {

	var orderId = $.getHashParams("orderId");
	orderId = orderId ? orderId : "01201708160003";
	var orderPrice = 0;

	var isInvoic = true; // 是否提交发票

	// 获取订单详情信息
	var getDetail = function() {
		var url = Utils.getBaseUrl("orderForm/findDetail.json"); // 根据id 查找订单  (包括 司机信息 是否完善信息)
		var param = {
			id: orderId
		};
		$.zajax(url, param, true, {
			succ: function(json) {
				var detail = json.body;
				detail.beginTime = Dates.format(detail.beginTime, 'yyyy-MM-dd HH:mm');
				$.each(json.extra.sickness, function() {
					if(this.id == detail.sicknessId) {
						detail.sicknessName = this.name;
					}
				});
				if(detail.escortType == "SHIP") { // 护送类型:0.运送|1.监护(0.ship|1.tutelagey)
					detail.escortTypeName = "运送";
					$(".do-isOrderlyNurse").parents(".mui-input-row").removeClass("hide"); // 护理员护理
					$(".do-stretcherNum").parents(".mui-input-row").removeClass("hide"); // 担架抬运

					$(".do-isOxygen").parents(".mui-input-row").addClass("hide"); // 是否吸氧
					$(".do-nurse").parents(".mui-input-row").addClass("hide"); // 医生、护士、护理员护理
				} else {
					detail.escortTypeName = "监护";
					$(".do-isOrderlyNurse").parents(".mui-input-row").addClass("hide"); // 护理员护理
					$(".do-stretcherNum").parents(".mui-input-row").addClass("hide"); // 担架抬运

					$(".do-isOxygen").parents(".mui-input-row").removeClass("hide"); // 是否吸氧
					$(".do-nurse").parents(".mui-input-row").removeClass("hide"); // 医生、护士、护理员护理
				}
				detail.stretcherNum = detail.stretcherNum + "人";
				detail.isOxygen == true ? detail.isOxygen = "是" : detail.isOxygen = "否";
				var nurse = [];
				if(detail.isDoctorNurse == true) {
					nurse.push("医生");
				}
				if(detail.isNurserNurse == true) {
					nurse.push("护士");
				}
				if(detail.isOrderlyNurse == true) {
					nurse.push("护理员");
				}
				detail.nurse = nurse.splice(",");
				detail.isOrderlyNurse == true ? detail.isOrderlyNurse = "是" : detail.isOrderlyNurse = "否";
				orderPrice = detail.orderPrice.toFixed(2);
				detail.orderPrice = detail.orderPrice.toFixed(2);
				if(detail.motormanId) {
					detail.driverRealName = detail.options.extra.driverRealName;
					detail.driverPhone = detail.options.extra.driverPhone;
				}
				
				// 显示过桥过路费
				if(detail.tollPrice){
					$(".do-tollPrice").removeClass("hide");
				}
				
				$(document.body).fillData(detail);

				// 是否完善信息 true:是,false:否
				var isPerfectInformation = detail.options.extra.isPerfectInformation;
				// 订单状态:0.待付款|1.付款中|2.待派单|3.已派单|4.已完成|5.已关闭|6.已退单(0.unpay|1.paying|2.unassign|3.assigned|4.finished|5.closed|6.backed)
				var orderState = detail.orderState;
				if(!isPerfectInformation && orderState != "UNPAY" && orderState != "CLOSED" && orderState != "BACKED") {
					$(".mui-content-padded").find("button.do-perfect-information").removeClass("hide");
					$(".do-perfect-tip").removeClass("hide");
				} else {
					$(".mui-content-padded").find("button.do-perfect-information").addClass("hide");
					$(".do-perfect-tip").addClass("hide");
				}

				isInvoic = detail.options.extra.isInvoic; // 是否提交发票

				// 评价状态:0.未评价|1.已评价(0.unevaluate|1.evaluated)
				var evaluateState = detail.evaluateState;
				if(orderState == "UNPAY") { // 0.待付款
					$(".do-diver").addClass("hide");

					$(".mui-content-padded").find("button.do-cancel").removeClass("hide");
					$(".mui-content-padded").find("button.do-pay").removeClass("hide");
				} else if(orderState == "PAYING" || orderState == "UNASSIGN") { // 1.付款中  || 2.待派单
					$(".do-diver").addClass("hide");

					// 支付操作:待付款-->付款中||待派单
					$(".mui-content-padded").find("button.do-cancel").addClass("hide");
					$(".mui-content-padded").find("button.do-pay").addClass("hide");
				} else if(orderState == "ASSIGNED") { // 3.已派单
					$(".do-diver").removeClass("hide");

					$(".mui-content-padded").find("button.do-complete").removeClass("hide");
				} else if(orderState == "FINISHED" && evaluateState == "UNEVALUATE") { // 4.已完成  && 0.未评价
					$(".do-diver").removeClass("hide");

					$(".mui-content-padded").find("button.do-evaluate").removeClass("hide").data("state", "unevaluate");
					// 确认完成操作:已派单-->已完成,未评价
					//$(".mui-content-padded").find("button.do-complete").addClass("hide");
				} else if(orderState == "FINISHED" && evaluateState == "EVALUATED") { // 4.已完成  && 1.已评价
					$(".do-diver").removeClass("hide");

					$(".mui-content-padded").find("button.do-evaluate").removeClass("hide").data("state", "evaluated");
				} else if(orderState == "CLOSED") { // 5.已关闭
					$(".do-diver").removeClass("hide");

					$(".mui-content-padded").find("button.do-evaluate").addClass("hide");
					// 取消操作:待付款-->已关闭
					//$(".mui-content-padded").find("button.do-cancel").addClass("hide");
					//$(".mui-content-padded").find("button.do-pay").addClass("hide");
				}

				// 如果有按钮不隐藏 则显示.mui-content-padded
				$(".mui-content-padded button").each(function() {
					if(!$(this).hasClass("hide")) {
						$(".mui-content-padded").removeClass("hide");
					}
				});
				
				// 如果只有一个按钮的样式
				if($(".mui-content-padded button.hide").length == 4){
					$("button").css("margin-left",0);
				}

				// 付款后到已评价都有开发票按钮
				if(orderState == "PAYING" || orderState == "UNASSIGN" || orderState == "ASSIGNED" || orderState == "FINISHED") {
					$(".do-invoice").removeClass("hide");
				}

				// 订单状态 已结束,已关闭,已退单 时 图片不可修改
				if(orderState == "FINISHED" || orderState == "CLOSED" || orderState == "BACKED") {
					getImg(true);
				} else {
					getImg();
					findUploadTipByOrder();
				}

			},
			fail: function(json) {

			}
		});
	}

	// 获取订单已上传的图片(根据当前登录人)
	var getImg = function(flag) {
		var url = Utils.getBaseUrl("orderAccessory/list.json"); // 查找订单所对应的图片(根据当前登录人)
		$.zajax(url, {
			orderId: orderId
		}, true, {
			succ: function(json) {
				
				if(flag) { // 只查看
					if(json.body.length > 0) {
						$(".do-pic").removeClass("hide");
						var html = Utils.baidu.template("list-img-ready", json.body);
						$(".do-camera").html(html);
					}
				} else { // 可编辑
					$(".do-pic").removeClass("hide");
					var html = Utils.baidu.template("list-img", json.body);
					$(".do-camera").append(html);
					if(json.body.length >= 5) {
						$(".camera").hide();
					}
				}
			},
			fail: function(json) {
				
			}
		});
	}

	var findUploadTipByOrder = function() {
		var url = Utils.getBaseUrl("configure/findUploadTipByOrder.json"); // 获取 订单详情页面的提示上传图片提示
		$.zajax(url, "", true, {
			succ: function(json) {
				$(".upload-tip").html(json.body.configValue);
			},
			fail: function(json) {

			}
		});
	}

	window.refresh = function() {
		init();
	}

	// 取消订单
	var cancel = function(orderId) {
		var url = Utils.getBaseUrl("orderForm/closed.json");
		var param = {
			id: orderId
		};
		$(".do-cancel").zajax(url, param, true, {
			succ: function(json) {
				/*Utils.toast("订单已取消");*/
				// 执行订单列表页面  下拉刷新方法
				Utils.nav.invoke("personal/order-list", "refresh");
				Utils.nav.back();
			},
			fail: function(json) {

			}
		});
	}

	// 确认完成
	var complete = function() {
		var url = Utils.getBaseUrl("orderForm/complete.json");
		var param = {
			id: orderId
		};
		$(".do-complete").zajax(url, param, true, {
			succ: function(json) {
				/*Utils.toast("确认完成成功");*/
				// 执行订单列表页面  下拉刷新方法
				Utils.nav.invoke("personal/order-list", "refresh");
				Utils.nav.back();
			},
			fail: function(json) {

			}
		});
	}

	var init = function() {
		$("input[name=orderId]").val(orderId);
		getDetail();
	}

	mui.ready(function() {

		mui(".mui-scroll-wrapper").scroll(); //初始化滚动
		mui.previewImage(); // 大图预览初始化

		// 点击"发票"
		$(".do-invoice").on('tap', function() {
			if(isInvoic) {
				Utils.nav.next("/views/personal/order-invoice-detail.html", {
					orderId: orderId
				});
			} else {
				Utils.nav.next("/views/personal/order-invoice.html", {
					orderId: orderId
				});
			}
		});

		/*mui.init({
			beforeback: function() {
				Utils.nav.replace("/views/personal/order-list.html");
				//Utils.nav.back("personal/order-list");
				return false;
			}
		});*/

		// 点击"取消"
		$(".do-cancel").on('tap', function() {
			mui.confirm('确定取消订单吗？', '警告', ['否', '是'], function(e) {
				if(e.index == 0) {} else {
					cancel(orderId);
				}
			})
		});

		// 点击"评价"
		$(".do-evaluate").on('tap', function() {
			var evaluateState = $(this).data("state");
			// 评价状态:0.未评价|1.已评价(0.unevaluate|1.evaluated)
			Utils.nav.next("/views/personal/evaluate.html", {
				orderId: orderId,
				evaluateState: evaluateState
			});
		});

		// 点击"确认完成"
		$(".do-complete").on('tap', function() {
			complete();
		});

		// 点击"完善信息"
		$(".do-perfect-information").on('tap', function() {
			Utils.nav.next("/views/personal/perfect-information.html");
		});

		// 点击"支付"
		$(".do-pay").on('tap', function() {
			Utils.nav.next("/views/personal/payment.html", {
				orderId: orderId,
				orderPrice: orderPrice
			});
		});

		// 点击"蒙层上部"
		$(".backdrop-top").on('tap', function(e) {
			
			e.stopPropagation();
			//$(".mui-backdrop-other1").addClass("hide");
		});

		// 点击"×" icon
		$(".mui-icon-closeempty").on('tap', function() {
			
			$(".mui-backdrop-other1").addClass("hide");
		});

		// 点击 明细
		$(".price-detail").on("tap", function() {
			
			$(".mui-backdrop-other").removeClass("hide");
		})

		// 点击"蒙层"
		$(".mui-backdrop-other").on('tap', function(e) {
			
			e.stopPropagation();
			$(".mui-backdrop-other").addClass("hide");
		});
		$(".price-detail-box").on('tap', function(e) {
			
			e.stopPropagation();
		});

		// 点击 提交
		/*$(".do-submit").on("tap", function() {
			var $form = $("form[name=upload]");
			var url = Utils.getBaseUrl("orderAccessory/create.json");
			$form.zajax(url, true, {
				succ: function(json) {
					
				},
				fail: function(json) {
					
				}
			});
			return false;
		});*/

		init();

	})

	mui.plusReady(function() {

		//图片改变回调
		$(".do-camera").on("change", function(event, e) {
			var $form = $("form[name=upload]");
			if(e.index == undefined) { // add
				var url = Utils.getBaseUrl("orderAccessory/create.json"); // 保存图片
				$form.zajax(url, true, {
					succ: function(json) {
						
						var id = json.body;
						e.target.attr("data-detail-id", id);
						e.target.find("img").removeAttr("data-zupload");
						Utils.toast("图片上传成功");
					},
					fail: function(json) {
						
					}
				});
			} else { // delete
				var id = e.target.attr("data-detail-id");
				
				var url = Utils.getBaseUrl("orderAccessory/delete.json"); // 删除图片
				$.zajax(url, {
					id: id
				}, true, {
					succ: function(json) {
						
						var id = json.body;
						e.target.attr("data-detail-id", id);
					},
					fail: function(json) {
						
					}
				});
			}
			return false;
		});

	})

}(jQuery);