+ function($) {

	var rows = 10; // 每页 条数
	var page;

	var waitingTotal;
	var alreadyTotal;

	var intervalObject;
	// 判断是否无数据
	var interval = function() {
		if((waitingTotal && alreadyTotal) || (waitingTotal == 0 && alreadyTotal == 0)) {
			if(waitingTotal == 0 && alreadyTotal == 0) {
				var html = Utils.baidu.template("list-empty", "");
				$(".do-empty").html(html);
				$(".mui-pull-bottom-pocket").addClass("hide");
			} else {
				$(".do-empty").empty();
				$(".mui-pull-bottom-pocket").removeClass("hide");
			}

			mui('#pullrefresh').pullRefresh().endPulldownToRefresh(); //refresh completed
			mui('#pullrefresh').pullRefresh().refresh(true);

			clearInterval(intervalObject);
		}
	}

	var pulldownRefresh = function() {
		$(".do-waiting").empty();
		$(".do-already").empty();
		page = 1;
		getWaiting();
		getAlready();

		intervalObject = setInterval(interval, 500);
	}

	window.refresh = function() {
		pulldownRefresh();
	}

	var pullupRefresh = function() {
		getAlready(++page);
	}

	// 构建模板
	var bulid = function(json) {
		var list = json.body;
		var orderState = json.extra.OrderState;
		var EvaluateState = json.extra.EvaluateState;
		$.each(orderState, function() {
			// 订单状态:0.待付款|1.付款中|2.待派单|3.已派单|4.已完成|5.已关闭|6.已退单(0.unpay|1.paying|2.unassign|3.assigned|4.finished|5.closed|6.backed)
			if(this.key == "UNPAY") {
				this.orderClass = "waiting-pay";
			} else if(this.key == "PAYING") {
				this.orderClass = "waiting-pay";
			} else if(this.key == "UNASSIGN") {
				this.orderClass = "waiting-dispatch";
			} else if(this.key == "ASSIGNED") {
				this.orderClass = "already-dispatch";
			} else if(this.key == "FINISHED") {
				this.orderClass = "waiting-evaluate";
			} else if(this.key == "CLOSED" || this.key == "BACKED") {
				this.orderClass = "already-evaluate";
			}
		});
		$.each(list, function(i, data) {
			$.each(orderState, function() {
				if(data.orderState == this.key) {
					data.orderStateName = this.value;
					data.orderClass = this.orderClass;
				}
			});
		});
		$.each(list, function(i, data) {
			// 评价状态:0.未评价|1.已评价(0.unevaluate|1.evaluated)
			$.each(EvaluateState, function() {
				if(data.evaluateState == this.key && data.orderState == "FINISHED") { // 已完成 才有 评价||未评价
					data.orderStateName = this.value;
				}
			});
		});
		var html = Utils.baidu.template("list", list);
		return html;
	}

	// 获取未完成订单
	var getWaiting = function() {
		var url = Utils.getBaseUrl("orderForm/list.json");
		var param = {
			orderStates: "UNPAY,PAYING,UNASSIGN,ASSIGNED",
			paging: "false",
			rows: rows
		};
		$.zajax(url, param, false, {
			succ: function(json) {
				var html = bulid(json);
				$(".do-waiting").html(html);

				waitingTotal = json.extra.total;
				if(json.extra.total == 0) {
					$(".waiting-tip-line").addClass("hide");
					$(".already-tip-line").css("height", "4.1667rem").css("line-height", "4.1667rem");
				} else {
					$(".waiting-tip-line").removeClass("hide");
					$(".already-tip-line").css("height", "2.9167rem").css("line-height", "1.8333rem");
				}

			},
			fail: function(json) {

			}
		});
	}

	// 获取已完成订单
	var getAlready = function(page) {
		var url = Utils.getBaseUrl("orderForm/list.json");
		var param = {
			orderStates: "FINISHED,CLOSED,BACKED",
			page: page,
			rows: rows
		};
		$.zajax(url, param, false, {
			succ: function(json) {
				var html = bulid(json);
				var length = json.body.length;
				if(length < rows) {
					mui('#pullrefresh').pullRefresh().endPullupToRefresh(true);
				} else {
					mui('#pullrefresh').pullRefresh().endPullupToRefresh(false);
				}
				$(".do-already").append(html);

				alreadyTotal = json.extra.total;
				if(json.extra.total == 0) {
					$(".already-tip-line").addClass("hide");
				} else {
					$(".already-tip-line").removeClass("hide");
				}

			},
			fail: function(json) {

			}
		});
	}

	// 取消订单
	var cancel = function(orderId) {
		var url = Utils.getBaseUrl("orderForm/closed.json");
		var param = {
			id: orderId
		};
		$(".do-submit").zajax(url, param, true, {
			succ: function(json) {
				/*Utils.toast("订单已取消");*/
				refresh();
			},
			fail: function(json) {

			}
		});
	}

	mui.ready(function() {

		mui.init({
			pullRefresh: {
				container: "#pullrefresh", //下拉刷新容器标识，querySelector能定位的css选择器均可，比如：id、.class等
				down: {
					style: 'circle', //必选，下拉刷新样式，目前支持原生5+ ‘circle’ 样式
					color: '#2BD009', //可选，默认“#2BD009” 下拉刷新控件颜色
					height: '50px', //可选,默认50px.下拉刷新控件的高度,
					range: '100px', //可选 默认100px,控件可下拉拖拽的范围
					offset: '44px', //可选 默认0px,下拉刷新控件的起始位置
					auto: true, //可选,默认false.首次加载自动上拉刷新一次
					callback: pulldownRefresh //必选，刷新函数，根据具体业务来编写，比如通过ajax从服务器获取新数据；
				},
				up: {
					height: 100, //可选.默认50.触发上拉加载拖动距离
					auto: false, //可选,默认false.自动上拉加载一次
					contentrefresh: "正在加载...", //可选，正在加载状态时，上拉加载控件上显示的标题内容
					contentnomore: '没有更多数据了', //可选，请求完毕若没有更多数据时显示的提醒内容；
					callback: pullupRefresh //必选，刷新函数，根据具体业务来编写，比如通过ajax从服务器获取新数据；
				}
			}
		});

		// 点击 icon-wrong
		mui(".list").on('tap', ".icon-wrong", function(e) {
			$this = $(this);
			e.stopPropagation();
			mui.confirm('确定取消订单吗？', '警告', ['否', '是'], function(e) {
				if(e.index == 0) {} else {
					var orderId = $this.parent().data("id");
					cancel(orderId);
				}
			})
		});

		// 点击 列表
		mui(".list").on('tap', ".do-card-box", function(e) {
			e.stopPropagation();
			var orderId = $(this).data("id");
			Utils.nav.next("/views/personal/order-detail.html", {
				orderId: orderId
			});
		});

	})

}(jQuery);