+ function($) {

	mui.plusReady(function() {

		var passParams = $.getHashParams();
		var orderId = passParams.orderId;
		var orderPrice = passParams.orderPrice;
		$(".do-order-price").html(orderPrice);

		var wxChannel = null; // 微信支付
		var aliChannel = null; // 支付宝支付

		// 点击支付box
		mui(".pay-box-outter").on('tap', ".pay-box", function(e) {
			e.stopPropagation();
			$(this).closest("form").find("[type='checkbox']").prop("checked", false);
			$(this).find(".new-checkbox").prop("checked", true);
		});

		// 点击 支付
		$(".do-submit").on('tap', function() {
			var value = $("input:checked").val();
			if(!value) {
				Utils.toast("请选择一种支付方式！");
			}
			if(value == "cash") {
				//现金支付
				updateOrder({payType:"CASH"}, function(){
					//关闭之前页面
					Utils.nav.close("personal/trip-information");
					Utils.nav.close("personal/trip-information-confirm");
					Utils.nav.replace("/views/personal/order-detail.html", {orderId:orderId});
				});
			} else {
				pay(value);
			}
		});
		
		//修改订单
		var updateOrder = function(params, succ, fail){
			params.id = orderId;
			var url = Utils.getBaseUrl("orderForm/updateState.json");
			$.zajax(url, params, true, {
				succ: function(json) {
					Utils.nav.invoke("personal/order-detail", "refresh");
					Utils.nav.invoke("personal/order-list", "refresh");
					succ&&succ();
				},
				fail: function(json) {
					fail&&fail();
				}
			});
		}

		// 获取支付通道
		plus.payment.getChannels(function(channels) {
			aliChannel = channels[0];
			wxChannel = channels[1];
		}, function(e) {
			mui.alert("获取支付通道失败：" + e.message, "提示");
		});

		function pay(id) {
			// 从服务器请求支付订单
			var PAYSERVER = '';
			var channel;
			var urlName;
			var payType;
			var trade_type = '';
			if(id == 'alipay') {
				channel = aliChannel;
				payType = "ALIPAY";
				urlName = "AliPay/getPayParam.json";
			} else if(id == 'wxpay') {
				channel = wxChannel;
				payType = "WEIXIN";
				urlName = "wxPay/pay.json";
				trade_type = "APP";
			}
			if(!channel || !channel.serviceReady) {
				mui.alert("请先下载您选择的支付客户端！", "提示");
				return;
			}
			var url = Utils.getBaseUrl(urlName);
			$.zajax(url, {
				orderNo: orderId,
				trade_type:trade_type
			}, true, {
				succ: function(json) {
					if(json.body) {
						var param = json.body;
						if(id == 'alipay'){
							param = $.param(param);
						}
						plus.payment.request(channel, param, function(result) {
							updateOrder({payType:payType, orderState:"PAYING"}, function(){
								Utils.nav.replace("/views/personal/pay-success.html", {orderId:orderId});
							}, function(){
								Utils.nav.replace("/views/personal/pay-success.html", {orderId:orderId});
							});
						}, function(error) {
							console.log(JSON.stringify(error));
						});
					} else {
						Utils.toast("支付参数异常！");
					}
				},
				fail: function(json) {

				}
			});
		}
	})

}(jQuery);