+ function($) {

	var $form = $("form[name=upload]");

	// 获取登录用户信息
	var getUserCoreInfo = function() {
		var url = Utils.getBaseUrl("userCore/findLoginUser.json");
		$.zajax(url, "", true, {
			succ: function(json) {
				var userCoreInfo = json.body;
				if(userCoreInfo.portrait) {
					$(".do-photo-url").attr("src", userCoreInfo.portrait);
				} else {
					$(".do-photo-url").attr("src", Utils.getBaseUrl("assets/img/home/default-photo.png"));
				}
				$(".do-phone").html(userCoreInfo.phone);
				var third = json.extra && json.extra.third;
				var qqBangding = false;
				var weixinBangding = false;
				if(third) {
					$.each(third, function(i, item) {
						if(item.thirdType == "WEIXIN") {
							weixinBangding = true;
						} else if(item.thirdType == "QQ") {
							qqBangding = true;
						}
					});
				}
				if(qqBangding) {
					$(".do-third-qq-state").html("已绑定");
					$(".do-third-qq-state").attr("data-state", true);
				} else {
					$(".do-third-qq-state").html("未绑定");
					$(".do-third-qq-state").attr("data-state", false);
				}
				if(weixinBangding) {
					$(".do-third-weixin-state").html("已绑定");
					$(".do-third-weixin-state").attr("data-state", true);
				} else {
					$(".do-third-weixin-state").html("未绑定");
					$(".do-third-weixin-state").attr("data-state", false);
				}
			},
			fail: function(json) {
				Utils.toast(json && json.message || "网络异常，请稍后重试");
			}
		});
	}

	window.refresh = function(newPhone) {
		$(".do-phone").html(newPhone);
	}

	// 修改头像
	/*var updatePhoto = function(photo) {
		var url = Utils.getBaseUrl("userCore/updatePhoto.json");
		var param = {
			photoUrl: photo
		};
		
//		$form.zajax(url, param, true, {
//			succ: function(json) {
//				loginUtils.autoLogin();
//				$(".do-photo-url").attr("src", photo);
//				Utils.toast("头像修改成功!");
//			},
//			fail: function(json) {
//				Utils.toast(json && json.message || "网络异常，请稍后重试");
//			}
//		});
	}*/

	var init = function() {
		getUserCoreInfo();
	}

	mui.plusReady(function() {

		mui(".mui-scroll-wrapper").scroll(); //初始化滚动

		// 点击"头像"
		$(".edit-camera").on("tap", function() {
			var url = Utils.getBaseUrl("userCore/updatePhoto.json");
			$(".do-photo-url").attr("data-zupload", "photoUrl");
			Utils.app.camera({
				title: '上传头像',
				width: '1500',
				height: '1500',
				callback: function(base64string) {
					$(".do-photo-url").attr("src", base64string);
					
					$form.zajax(url, {
						succ: function(e) {
							Utils.toast("头像修改成功!");
						}
					});
				}
			});
		});

		// 点击"手机号码"
		$(".do-change-phone").on("tap", function() {
			Utils.nav.next("/views/personal/change-phone.html");
		});

		// 点击"完善信息"
		$(".do-perfect-information").on("tap", function() {
			Utils.nav.next("/views/personal/perfect-information.html");
		});

		// 点击"修改密码"
		$(".do-update-password").on("tap", function() {
			Utils.nav.next("/views/personal/update-password.html");
		});

		//退出登录
		$(".do-outLogin").on("tap", function() {
			loginUtils.outLogin();
		});

		//解绑第三方信息
		var jiebang = function(thirdType) {
			var url = Utils.getBaseUrl("userThird/delete.json");
			$.zajax(url, {
				thirdType: thirdType
			}, true, {
				succ: function(json) {
					if(thirdType == "QQ") {
						$(".do-third-qq-state").html("未绑定");
						$(".do-third-qq-state").attr("data-state", false);
					} else {
						$(".do-third-weixin-state").html("未绑定");
						$(".do-third-weixin-state").attr("data-state", false);
					}
				},
				fail: function(json) {}
			});
		}

		//绑定第三方信息
		var bangdingThird = function(openid, thirdType) {
			thirdType = thirdType.toLocaleUpperCase();
			var url = Utils.getBaseUrl("userThird/create.json");
			$.zajax(url, {
				thirdCode: openid,
				thirdType: thirdType
			}, true, {
				succ: function(json) {
					if(thirdType == "QQ") {
						$(".do-third-qq-state").html("已绑定");
						$(".do-third-qq-state").attr("data-state", true);
					} else {
						$(".do-third-weixin-state").html("已绑定");
						$(".do-third-weixin-state").attr("data-state", true);
					}
				},
				fail: function(json) {}
			});
		}

		//第三方绑定
		var authWeixin;
		var authQQ;
		plus.oauth.getServices(function(auths) {
			for(var i = 0; i < auths.length; i++) {
				var authThis = auths[i];
				var id = authThis.id;
				if(id == 'weixin') {
					authWeixin = authThis;
					continue;
				} else if(id == 'qq') {
					authQQ = authThis;
					continue;
				}
			}
		}, function(e) {
			
		});
		var authThirdLogin = function(authThird) {
			authThird.login(function(e) {
				// 获取登录操作结果
				authThird.getUserInfo(function(e) {
					var openid = authThird.userInfo.openid || authThird.authResult.openid;
					bangdingThird(openid, authThird.id);
					authThird.logout(function(e) {}, function(e) {});
				}, function(e) {
					Utils.toast('获取用户信息失败');
				});
			}, function(e) {
				Utils.toast('第三方登录失败！');
			});
		}
		var thirdLogin = function(authThird) {
			authThirdLogin(authThird);
		}
		$(".do-third-weixin").on('tap', function() {
			var state = $(this).find(".do-third-weixin-state").attr("data-state");
			if(state == "true") {
				//解绑
				mui.confirm("确定解绑第三方信息吗？", "提示", ["取消", "确定"], function(e) {
					if(e.index != 0) {
						jiebang("WEIXIN");
					}
				});
			} else if(state == "false") {
				//绑定
				thirdLogin(authWeixin);
			}
		});
		$(".do-third-qq").on('tap', function() {
			var state = $(this).find(".do-third-qq-state").attr("data-state");
			if(state == "true") {
				mui.confirm("确定解绑第三方信息吗？", "提示", ["取消", "确定"], function(e) {
					if(e.index != 0) {
						jiebang("QQ");
					}
				});
			} else if(state == "false") {
				thirdLogin(authQQ);
			}
		});

		init();

	});

}(jQuery);