+ function($) {

	var cityPicker; // 城市picker
	var typePicker; // 护送类型picker

	var areaId; // 地区id
	var escortCode; // 护送类型

	// 获取 地区信息列表 和 护送类型
	var listArea = function() {
		var url = Utils.getBaseUrl("areaPartition/list.json"); // 获取 地区信息列表
		$.zajax(url, "", true, {
			succ: function(json) {
				var list = json.body; // 地区信息列表
				var areaList = []; // 城市
				var defaultCity = {}; // 默认城市
				$.each(list, function() {
					var area = {};
					area.value = this.id;
					area.text = this.name;
					areaList.push(area);

					if(this.isDefault == true) { // 默认城市
						defaultCity.id = this.id;
						defaultCity.name = this.name;
					}
				});
				// 给 cityPicker 设置数据
				cityPicker.setData(areaList);
				areaId = defaultCity.id;
				cityPicker.pickers[0].setSelectedValue(areaId, 2000);
				$(".do-city").html(defaultCity.name);

				// 护送类型:0.运送|1.监护(0.ship|1.tutelagey)
				var escortType = json.extra.EscortType
				var typeList = []; // 城市
				$.each(escortType, function() {
					var type = {};
					type.value = this.key;
					type.text = this.value;
					typeList.push(type);
				});
				// 给 typePicker 设置数据
				typePicker.setData(typeList);
				escortCode = escortType[0].key;
				typePicker.pickers[0].setSelectedValue(escortCode, 2000);
				$(".do-type").html(escortType[0].value);

				listByAreaId();
			},
			fail: function(json) {

			}
		});
	}

	// 根据城市地区id(area_id)获取 价格体系
	var listByAreaId = function() {
		var url = Utils.getBaseUrl("priceSystem/findSystem.json"); // 根据城市地区id(area_id)和护送类型 获取价格体系
		var param = {
			areaId: areaId,
			escortType: escortCode
		};
		$.zajax(url, param, true, {
			succ: function(json) {
				
				var detail = json.body; // 价格体系
				if(detail.escortType == "SHIP") { // 运送型 SHIP
					$(".do-ship").removeClass("hide");
					$(".do-tutelage").addClass("hide");
					ship = this;
				} else { // 监护型 TUTELAGEY
					$(".do-tutelage").removeClass("hide");
					$(".do-ship").addClass("hide");
					tutelagey = this;
				}
				$(document.body).fillData(detail);
			},
			fail: function(json) {

			}
		});
	}

	var init = function() {
		listArea();
	}

	mui.ready(function() {

		mui(".mui-scroll-wrapper").scroll(); //初始化滚动

		// 选择城市
		cityPicker = new mui.PopPicker();
		$(".city-picker").on("tap", function() {
			$(this).find(".down-arrow").addClass("rotate-180");
			cityPicker.show(function(selectItems) {
				areaId = selectItems[0].value;
				$(".do-city").html(selectItems[0].text);
				listByAreaId();
				$(".city-picker").find(".down-arrow").removeClass("rotate-180");
			}, function() {
				$(".city-picker").find(".down-arrow").removeClass("rotate-180");
			})
		});

		// 选择护送类型
		typePicker = new mui.PopPicker();
		$(".type-picker").on("tap", function() {
			$(this).find(".down-arrow").addClass("rotate-180");
			typePicker.show(function(selectItems) {
				escortCode = selectItems[0].value;
				$(".do-type").html(selectItems[0].text);
				listByAreaId();
				$(".type-picker").find(".down-arrow").removeClass("rotate-180");
			}, function() {
				$(".type-picker").find(".down-arrow").removeClass("rotate-180");
			})
		});

		init();
	})

}(jQuery);