+ function($) {

	//var orderSource = "CONSUMER"; // 订单来源:0.消费者|1.助手(0.consumer|1.salesman)

	var sicknessInfoList = []; // 疾病信息列表
	var convoyType = ""; // 护送类型
	var sicknessId = ""; // 所患疾病Id

	var orderPrice; // 订单价格
	//var distance = ""; // 出行距离	

	var orderId; // 订单id
	//var oldPrice; // 老的订单价格
	//var isCancelFlag = undefined; // 价格改变和是否点击取消标识

	// 地图字段
	var location; // 地图位置
	var linkCode; // 城市 地图关联标识

	var diseasePicker = new mui.PopPicker(); // 所患疾病

	var $form = $("form[name=trip]");

	// 获取 疾病信息列表
	var getSicknessInfoList = function() {
		var url = Utils.getBaseUrl("sicknessInfo/list.json"); // 获取 疾病信息列表
		$.zajax(url, "", true, {
			succ: function(json) {
				var list = json.body;
				$.each(list, function() {
					var sickness = {};
					sickness.value = this.id;
					sickness.text = this.name;
					sicknessInfoList.push(sickness);
				});
				// 给 diseasePicker 设置数据
				diseasePicker.setData(sicknessInfoList);
			},
			fail: function(json) {

			}
		});
	}

	// 计算价格
	var calculatePrice = function(flag) {
		$(".do-submit").addClass("mui-disabled"); // 禁用提交
		var param = $form.serializeJson();
		param.areaId = linkCode; // 地区id(这里是地区标识)
		param.originCode = JSON.stringify(location.originCode); // 起点地图标识 
		param.terminalCode = JSON.stringify(location.terminalCode); // 终点地图标识
		//param.distance = distance; // 出行距离
		param.beginTime = param.beginTime + ":00";
		param.sicknessId = sicknessId;

		var url = Utils.getBaseUrl("orderForm/calculatePrice.json"); // 计算订单总价 返回明细
		$.zajax(url, param, true, {
			succ: function(json) {
				
				var priceDetail = json.body; // 价格明细
				priceDetail.distance = priceDetail.options.extra.distance; // 出行距离
				priceDetail.totalPrice = priceDetail.options.extra.totalPrice.toFixed(2);
				orderPrice = priceDetail.options.extra.presentPrice.toFixed(2);
				priceDetail.presentPrice = orderPrice;
				priceDetail.remark = priceDetail.options.extra.remark;
				priceDetail.toll = priceDetail.options.extra.toll; // 过路费

				/*if(flag && orderPrice != $(".present-price").html()) { // 提交时价格改变
					isCancelFlag = 1;
				} else {
					isCancelFlag = 2;
				}*/

				if(priceDetail.remark) {
					$(".do-remark").parents(".mui-input-row").removeClass("hide");
				}
				if(priceDetail.toll) {
					$(".do-toll").parents(".mui-input-row").removeClass("hide");
				}
				$(document.body).fillData(priceDetail);

				$(".do-submit").removeClass("mui-disabled"); // 启用提交
			},
			fail: function(json) {

			}
		});
	}

	// 验证必填项 return true/false
	var check = function() {
		$form.zhhvalidate({
			tips: false,
			failFast: true
		}, function(e) {
			if(e.passed) {
				calculatePrice();
			}
		});
	}

	// 新增或修改
	var createOrUpdate = function(url, param) {
		$.zajax(url, param, true, {
			succ: function(json) {
				orderId = json.body && json.body.id;

				if(json.body.orderPrice != $(".present-price").html()) { // 提交时价格改变
					mui.confirm("订单价格已发生改变,确定提交?", "警告", ["取消", "确定"], function(e) {
						if(e.index == 0) { // 点击 "取消"
							calculatePrice();
							return;
						} else {
							calculatePrice();
							Utils.nav.next("/views/personal/trip-information-confirm.html", {
								orderId: orderId
							});
						}
					})
				} else {
					Utils.nav.next("/views/personal/trip-information-confirm.html", {
						orderId: orderId
					});
				}

				$(".do-submit").removeClass("mui-disabled"); // 启用提交

			},
			fail: function(json) {

			}
		});
	}

	var init = function() {
		getSicknessInfoList();
	}

	mui.plusReady(function() {
		//mui.ready(function() {
		mui(".mui-scroll-wrapper").scroll(); //初始化滚动

		
		location = Utils.getPassParams(); // 地图位置
		/*location = {
			"city": "南京市",
			"zhongdianCity": "南京市",
			"origin": "江苏省南京市江宁区天元中路",
			"originCode": {
				"longitude": 118.838235,
				"latitude": 31.935434
			},
			"terminal": "鼓楼公园",
			"terminalCode": {
				"longitude": 118.788486,
				"latitude": 32.064884
			}
		};*/
		$("input[name=origin]").val(location.origin);
		$("input[name=terminal]").val(location.terminal);
		linkCode = location.city;

		// 预约出行时间
		var pickerTime = new mui.DtPicker({
			type: "datetime",
			beginDate: new Date()
		});
		$(".do-picker-time").on("tap", function() {
			pickerTime.show(function(rs) {
				$("input[name=beginTime]").val(rs.text);
				check();
			});
		})

		// 点击 起点 行
		$(".do-origin").on("tap", function() {
			//check();
		})

		// 点击 终点 行
		$(".do-terminal").on("tap", function() {
			//check();
		})

		// 所患疾病
		$(".do-disease-picker").on("tap", function() {
			diseasePicker.show(function(selectItems) {
				$("input[name=sicknessId]").val(selectItems[0].text);
				sicknessId = selectItems[0].value;
				check();
			})
		})

		// 护送类型
		var convoyPicker = new mui.PopPicker();
		convoyPicker.setData([{
			value: '0',
			text: '运送性'
		}, {
			value: '1',
			text: '监护型'
		}]);
		$(".do-convoy-picker").on("tap", function() {
			convoyPicker.show(function(selectItems) {
				$(".do-escortType").val(selectItems[0].text);
				$("input[name=escortType]").val(selectItems[0].value == 0 ? "SHIP" : "TUTELAGEY");
				convoyType = selectItems[0].value;
				if(convoyType == 0) { // 0:运送性
					$(".bbr").css("top", "319px");
					$(".price-detail-box").css("max-height", "225px");
					$(".do-ship").removeClass("hide");
					$(".do-tutelage").addClass("hide");
				} else { // 1:监护型
					$(".bbr").css("top", "479px");
					$(".price-detail-box").css("max-height", "385px");
					$(".do-ship").addClass("hide");
					$(".do-tutelage").removeClass("hide");
				}
				check();
			})
		})

		// input change
		$("input").on("change", function() {
			check();
		})

		// 点击 明细
		$(".do-price-detail").on("tap", function() {
			$(".mui-backdrop-other").removeClass("hide");
		})

		// 点击"蒙层"
		$(".mui-backdrop-other").on('tap', function(e) {
			e.stopPropagation();
			$(".mui-backdrop-other").addClass("hide");
		});
		$(".price-detail-box").on('tap', function(e) {
			e.stopPropagation();
		});

		// 点击 提交
		$(".do-submit").on("tap", function() {

			$(".do-submit").addClass("mui-disabled"); // 禁用提交
			//isCancelFlag = undefined;

			if(loginUtils.checkLoginState()) { // 判断是否已经登录
				$form.zhhvalidate({
					tips: false,
					failFast: true
				}, function(e) {
					if(e.passed) {
						var param = $form.serializeJson();
						//param.orderPrice = orderPrice;
						param.sicknessId = sicknessId;
						param.beginTime = param.beginTime + ":00";
						param.areaId = linkCode; // 地区id(这里是地区标识)
						param.originCity = location.city; // 起点城市
						param.originCode = JSON.stringify(location.originCode); // 起点地图标识 
						param.terminalCity = location.zhongdianCity; // 终点城市
						param.terminalCode = JSON.stringify(location.terminalCode); // 终点地图标识
						//param.distance = distance; // 出行距离
						//param.orderSource = orderSource;
						//param.orderState = "UNPAY"; // 订单状态:0.待付款|1.付款中|2.待派单|3.已派单|4.已完成|5.已关闭(0.unpay|1.paying|2.unassign|3.assigned|4.finished|5.closed)

						//var intervalObject;
						//var interval = function() {
						/*if(isCancelFlag) {
							if(isCancelFlag == 1) { // 改变了
								mui.confirm("订单价格已发生改变,确定提交?", "警告", ["取消", "确定"], function(e) {
									if(e.index == 0) { // 点击 "取消"
										return;
									} else {
										if(orderId) { // 存在id 修改
											
											param.id = orderId;
											var url = Utils.getBaseUrl("orderForm/update.json"); // 修改订单
											createOrUpdate(url, param);
										} else { // 不存在 id 新增
											
											var url = Utils.getBaseUrl("orderForm/create.json"); // 创建订单
											createOrUpdate(url, param);
										}
									}
								})
							} else {*/
						if(orderId) { // 存在id 修改
							
							param.id = orderId;
							var url = Utils.getBaseUrl("orderForm/update.json"); // 修改订单
							createOrUpdate(url, param);
						} else { // 不存在 id 新增
							
							var url = Utils.getBaseUrl("orderForm/create.json"); // 创建订单
							createOrUpdate(url, param);
						}
						/*}*/
						//clearInterval(intervalObject);
						//}

						//}
						// 计算价格是否改变
						//calculatePrice(true);
						//intervalObject = setInterval(interval, 500);

					} else {
						Utils.toast(e.text);
					}
				});
			} else {
				// 未登录
				Utils.nav.next("/views/home/login.html");
			}

			// 下一个页面会执行这个方法  来获取订单id
			window.addEventListener('getOrderId', function(event) {
				orderId = event.detail.orderId;
				//oldPrice = $(".present-price").html();
			});

		})

		init();

	})

}(jQuery);